/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.8 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 08.03.2008
Author  : CronOS                          
Company :                            
Comments:      DS1621 
               I2C.

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <stdio.h>									   
#define SDA_PIN     1									   
#define SCL_PIN     0									   
#define I2C_PORTIN  PINB									  
#define I2C_PORT    PORTB								   
#define I2C_DDR     DDRB									   
#include "My_I2C.h"


#define ADRESS_LCD_RW0  0x78   //  A0 + R/W = 0 ()
#define ADRESS_LCD_RW1  0x79   //  A0 + R/W = 1 ()
unsigned char i;               //  

/*
    
*/     
void T190_INIT(void){ 
  DDRB.2 = 1;
  PORTB.2 = 1;
  I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x00);  //  
  I2C_WriteByte(0x31);  //  001( )1(  X)0(  Y)0(  (0-))  ..
  I2C_WriteByte(0x14);  //bias system 4 !!!
  I2C_WriteByte(0x06);  // 
  I2C_WriteByte(0x30);  //   
  I2C_WriteByte(0x11);  //   3x
  I2C_WriteByte(0x05);  //   LCD
  I2C_WriteByte(0x31);  //  001( )1(  X)0(  Y)0(  (0-))  ..
  I2C_WriteByte(0x9A);  //  VRAM X 26???
  I2C_WriteByte(0x0C);  //   
  I2C_WriteByte(0x30);  //   
  I2C_WriteByte(0x0C);  //   
  I2C_WriteByte(0x40);  //   = 0
  I2C_WriteByte(0x80);  //   = 0
  I2C_Stop();           // .
  delay_ms(10);  
  I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);  //  +  R/W=0().
  I2C_WriteByte(0x00);  //    
  I2C_WriteByte(0x31);  //  001( )1(  X)0(  Y)0(  (0-))  ..
  I2C_WriteByte(0x00);  // 
  I2C_Stop();           // .

}
//  
void T190_Clear_Line(void){
  unsigned char j;
  I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x40);               // 
  for(j=0;j<97;j++){
    I2C_WriteByte(0x00);             //   98  (- )
  }
  I2C_Stop(); 
}
//   
void T190_CLS(void){
  for(i=0x40;i<0x48;i++){
    I2C_Start();
    I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
    I2C_WriteByte(0x00);               //   
    I2C_WriteByte(0x30);               //  
    I2C_WriteByte(i);                  //      
    I2C_WriteByte(0x80);               //        
    I2C_Stop();
    T190_Clear_Line();                 //  
  }  
}


void main(void)
{  

TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

//LCD_Init();         
//LCD_Clear();         
//LCD_CursorPos(1,0);  
T190_INIT();
T190_CLS();


 
I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x00);  // 
  I2C_WriteByte(0x30);  //       
  I2C_WriteByte(0x43);  //  X  3- 
  I2C_WriteByte(0xB0);  //  Y  50-         
I2C_Stop();

I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x40);  //   VRAM
  I2C_WriteByte(0x00);  //
  I2C_WriteByte(0x01);  //
  I2C_WriteByte(0x02);  //
  I2C_WriteByte(0x04);  //
  I2C_WriteByte(0x08);  //
  I2C_WriteByte(0x10);  //
  I2C_WriteByte(0x20);  //
  I2C_WriteByte(0x40);  //
  I2C_WriteByte(0x80);  //        
I2C_Stop();

   while(1)
   {
   
   }
}
