/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.8 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 08.03.2008
Author  : CronOS
Company :
Comments:      DS1621
               I2C.

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#include <stdio.h>
#define SDA_PIN     1
#define SCL_PIN     0
#define I2C_PORTIN  PIND
#define I2C_PORT    PORTD
#define I2C_DDR     DDRD
#include "My_I2C.h"


#define ADRESS_MEM_RW0  0xA0   //  A0 + R/W = 0 ()
#define ADRESS_MEM_RW1  0xA1   //  A0 + R/W = 1 ()
#define ADRESS_LCD_RW0  0x78   //  A0 + R/W = 0 ()
#define ADRESS_LCD_RW1  0x79   //  A0 + R/W = 1 ()
unsigned char buffer[30];



/*
      DS1621.
*/
unsigned int MEM_GET_ADDR(unsigned char data)
{
  unsigned char CHAR_ADDR;   //    
  unsigned char CHAR_WIDTH;  //     
  unsigned int Temp;       //  ...

  delay_ms(750);    //  DS1621   -.

  I2C_Start();
  I2C_WriteByte(ADRESS_MEM_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x00);  // 
  I2C_WriteByte(data);  // 

  I2C_Start();                      // .
  I2C_WriteByte(ADRESS_MEM_RW1);     //  ,    R/W=1 (    ).
  CHAR_ADDR = I2C_ReadByte(NACK);      //   ,     ACK (..    . ).
  I2C_Stop();                       // .
  /*
  Temp = Temp_TL;                   // ""     16- .
  Temp += ((int)(Temp_TH) << 8);
  Temp = (Temp >> 7);               //  11  ( -   ,
                                    //.  DS1621, .4).
  */
  return CHAR_ADDR;                      //  ""...
}


/*
    
*/
void T190_INIT(void){
  DDRD = 0x04;
  PORTD.2 = 1;
  I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x00);  // 
  I2C_WriteByte(0x31);  // 
  I2C_WriteByte(0x14);  // 
  I2C_WriteByte(0x06);  // 
  I2C_WriteByte(0x30);  // 
  I2C_WriteByte(0x11);  // 
  I2C_WriteByte(0x05);  // 
  I2C_WriteByte(0x31);  // 
  I2C_WriteByte(0x9A);  // 
  I2C_WriteByte(0x0C);  // 
  I2C_WriteByte(0x30);  // 
  I2C_WriteByte(0x0C);  // 
  I2C_WriteByte(0x40);  // 
  I2C_WriteByte(0x80);  // 
  I2C_Stop();
  delay_ms(10);
  I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);  // 
  I2C_WriteByte(0x00);  // 
  I2C_WriteByte(0x31);  // 
  I2C_WriteByte(0x00);  // 
  I2C_Stop();           // .

}


void DS1621_Temp(void)
{
  unsigned int Temp;          //   -  DS1621_GetTemp().
  char sign = '+';            // -    , -  .

  PORTB = MEM_GET_ADDR(0x2B);    //  -  .

  if((Temp >> 8) == 1)        //  , - .  .?    MSB  -.
  {
     Temp = (512 - Temp);     // - "" ))),  ,    )).
     sign = '-';
  }

  /*        ,   .*/
  /*   (%c -   ASCII),      -,
            5    10,   
       ,      % -   .  
     - 0xDF,   ASCII,    (..    )).*/
  //sprintf(buffer, "%c%u.%u%cC", sign, Temp*5/10, Temp*5%10, 0xDF);
  //LCD_CursorPos(1,5);
  //LCD_SendStr_S(buffer);
}

/*    EEPROM    
void MEMORY_Init(void){
  unsigned int Tmp;

  delay_ms(750);    //  DS1621   -.

  I2C_Start();
  I2C_WriteByte(ADRESS_MEM_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x00);  // 
  I2C_WriteByte(0x00);  // 

  //I2C_Start();                      // .
  I2C_WriteByte(ADRESS_MEM_RW0);     //  ,    R/W=1 (    ).
  for(Tmp=0;Tmp<64;Tmp++){
        I2C_WriteByte(Tmp);      //   ,     ACK (..    . ).
  }
  I2C_Stop();                       // .

  Temp = Temp_TL;                   // ""     16- .
  Temp += ((int)(Temp_TH) << 8);
  Temp = (Temp >> 7);               //  11  ( -   ,
                                    //.  DS1621, .4).


}
*/


void main(void)
{
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTD=0x00;
DDRD=0x04;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

//LCD_Init();
//LCD_Clear();
//LCD_CursorPos(1,0);
T190_INIT();
I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x00);  // 
  I2C_WriteByte(0x30);  //  
  I2C_WriteByte(0x43);  //  X  3- 
  I2C_WriteByte(0xB0);  //  Y  50- 
I2C_Stop();

I2C_Start();
  I2C_WriteByte(ADRESS_LCD_RW0);     //  +  R/W=0().
  I2C_WriteByte(0x40);  // 
  I2C_WriteByte(0x00);  // 
  I2C_WriteByte(0x01);  // 
  I2C_WriteByte(0x02);  // 
  I2C_WriteByte(0x04);  // 
  I2C_WriteByte(0x08);  // 
  I2C_WriteByte(0x10);  // 
  I2C_WriteByte(0x20);  // 
  I2C_WriteByte(0x40);  // 
  I2C_WriteByte(0x80);  // 
I2C_Stop();//MEMORY_Init();

   while(1)
   {
      DS1621_Temp();
   }
}
